#! /bin/sh
#main.sh: massage the data.in into data.lua, then run that file.
#Be sure to generate data.in first using gen_data.lua!

#Also, remove /dev/shm/data.lua when you're done, it's a big RAM hog-- I'm not
#doing it in this script because it's supposed to be a benchmark.

#Run this with time(1) to measure the amount of time this will take on your
#system. On an Intel Core i5 @2.53 Ghz, 3 gigs RAM and no swap, Linux 2.6.33
#kernel with the -ck patchset, and using stock Lua 5.1.4 (no luaJIT) it took
#me two minutes, plus or minus five seconds (I did three trials.) 

#Performance could be improved further by, for example, parallizing 
#massage_data.sh, which should be pretty easy. You could also tune the section
#size in that script. 80000 caused Lua to eat up all my RAM and crash. 40000 
#and 60000 seemed about the same performance-wise, I left it at 40000.

#Note that using /dev/shm for data.lua makes things a lot faster, but also 
#drives up RAM usage by the size of data.lua (about 270 mib.)

#If available, you should use dash instead of bash for efficiency.
echo "massaging input data"
dash massage_data.sh data.in > /dev/shm/data.lua

cd /dev/shm
echo "loading input data"
echo "require ('data')
print('loaded table of size',#data) --should be 3000000" | lua

